/** Plugin utilities */
var plugins = {};
function getPlugin(pluginKey) {
  var plugin = plugins[pluginKey];

  if (!plugin) {
    throw new Error("The plugin " + pluginKey + " has not been loaded into Immer. Make sure the require from \"immer/" + pluginKey + "\" when initializing your application, just after requiring immer itself.");
  } // @ts-ignore


  return plugin;
}
function loadPlugin(pluginKey, implementation) {
  plugins[pluginKey] = implementation;
}
function willFinalizeES5(scope, result, isReplaced) {
  getPlugin("es5").willFinalizeES5(scope, result, isReplaced);
}
function createES5Proxy(base, parent) {
  return getPlugin("es5").createES5Proxy(base, parent);
}
function proxyMap(target, parent) {
  return getPlugin("mapset").proxyMap(target, parent);
}
function proxySet(target, parent) {
  return getPlugin("mapset").proxySet(target, parent);
}
function generatePatches(state, basePath, patches, inversePatches) {
  getPlugin("patches").generatePatches(state, basePath, patches, inversePatches);
}
function applyPatches(draft, patches) {
  return getPlugin("patches").applyPatches(draft, patches);
}

export { applyPatches, createES5Proxy, generatePatches, getPlugin, loadPlugin, proxyMap, proxySet, willFinalizeES5 };
